let tableIngresos;
let rowTable = "";
let divLoading = document.querySelector("#divLoading");

var minDate, maxDate;
 
// Custom filtering function which will search data in column four between two values
$.fn.dataTable.ext.search.push(
 function( settings, data, dataIndex ) {
     var min = minDate.val();
     var max = maxDate.val();
     var date = new Date( data[7] );

     if (
         ( min === null && max === null ) ||
         ( min === null && date <= max ) ||
         ( min <= date   && max === null ) ||
         ( min <= date   && date <= max )
     ) {
         return true;
     }
     return false;
 }
);

document.addEventListener('DOMContentLoaded', function(){

// Create date inputs
minDate = new DateTime($('#min'), {
    format: 'DD/MM/YYYY'
});
maxDate = new DateTime($('#max'), {
    format: 'DD/MM/YYYY'
});

   var tableIngresos = $('#tableIngresos').DataTable( {

    footerCallback: function (row, data, start, end, display) {
        var api = this.api();

        // Remove the formatting to get integer data for summation
        var intVal = function (i) {
            return typeof i === 'string' ? i.replace(/[\$,]/g, '') * 1 : typeof i === 'number' ? i : 0;
        };            

       // Total over all pages
       importe = api
       .column(5,{ page: 'current' })
       .data()
       .reduce(function (a, b) {
           return intVal(a) + intVal(b);
       }, 0); 
       

   $(api.column(5).footer()).html('' + Math.round((importe + Number.EPSILON)*100 )/100);
    },
        "aProcessing":true,
        "aServerSide":true,
        "language": {
            "url": "//cdn.datatables.net/plug-ins/1.10.20/i18n/Spanish.json"
        },
        "ajax":{
            "url": " "+base_url+"/Egresos/getEgresos",
            "dataSrc":""
        },
        "columns":[
            
            {"data":"payment_id"},
            
            {"data":"title"},
            {"data":"description"}, 
            {"data":"name"}, 

            {"data":"payment_type"}, 
 
            
            {"data":"amount"}, 
            {"data":"method"}, 
            {"data":"timestamp"}, 
            
        ],
        searchPanes: {
            layout: 'columns-3',
            //cascadePanes: true
            initCollapsed: true,
        },
        "columnDefs": [
                     {
                       // "targets": [0,3,4,6],
                        //"visible": false
                       // "searchable": false
                    },

                    { 'className': "textcenter", "targets": [ 0 ] },
                    { 'className': "textcenter", "targets": [ 1 ] },
                    { 'className': "textcenter", "targets": [ 3 ] },
                    { 'className': "textcenter", "targets": [ 4 ] },
                    { 'className': "textcenter", "targets": [ 5 ] },
                    { 'className': "textcenter", "targets": [ 6 ] },
                    { 'className': "textcenter", "targets": [ 7 ] },
                    
                    {
                        searchPanes: {
                            show: false
                        },
                        
                    },
                  ], 
        'dom': 'Blfrtip',
        'buttons': [
            {
                "extend": "excelHtml5",
                "text": "<i class='fas fa-file-excel'></i> Excel",
                "titleAttr":"Esportar a Excel",
                "className": "btn btn-success",
                "footer": "true",
                "exportOptions": { 
                    "columns": [0,1,2,3,4,5,6] 
                }
            },{
                "extend": "pdfHtml5",
                "text": "<i class='fas fa-file-pdf'></i> PDF",
                "titleAttr":"Esportar a PDF",
                "className": "btn btn-danger",
                "orientation": "landscape", 
                "footer": "true",
                "pageSize": "A4",
                "exportOptions": { 
                    "columns": [0,1,2,3,4,5,6] 
                },
                customize: function (doc) {
                    
                    //ancho de columnas al 100%
                    doc.content[1].table.widths = Array(doc.content[1].table.body[0].length + 1).join('*').split('');
                    
                    //doc.content[1].table.widths = [ '4%', '29%', '16%', '17%', '6%', '5%', '5%', '8%', '11%'];
                    doc.content.splice(0,1);                    
                    var now = new Date();
                    var jsDate = now.getDate()+'-'+(now.getMonth()+1)+'-'+now.getFullYear();
                    doc.pageMargins = [20,40,20,30];
                    doc.defaultStyle.fontSize = 9.5;
                    doc.styles.tableHeader.fontSize = 9.5;
                    doc['header']=(function() {
                        return {
                            columns: [
                                {
                                    alignment: 'center',
                                    fontSize: 12,
                                    text: 'TOTAL DE EGRESOS'
                                }
                            ],
                            margin: 15
                        }
                    });
                    doc['footer']=(function(page, pages) {
                        return {
                            columns: [
                                {
                                    alignment: 'left',
                                    text: ['Creado el: ', { text: jsDate.toString() }]
                                },
                                {
                                    alignment: 'right',
                                    text: ['Página ', { text: page.toString() },	' de ',	{ text: pages.toString() }]
                                }
                            ],
                            margin: 5
                        }
                    });
                    var objLayout = {};
                    objLayout['hLineWidth'] = function(i) { return .5; };
                    objLayout['vLineWidth'] = function(i) { return .5; };
                    objLayout['hLineColor'] = function(i) { return '#aaa'; };
                    objLayout['vLineColor'] = function(i) { return '#aaa'; };
                    objLayout['paddingLeft'] = function(i) { return 4; };
                    objLayout['paddingRight'] = function(i) { return 4; };
                    doc.content[0].layout = objLayout;
            }
            },
        ],
        "resonsieve":"true",
        "bDestroy": true,
        "iDisplayLength": 10,
        "order":[[0,"desc"]]  
        
    }); 
    
    // Refilter the table
    $('#min, #max').on('change', function () {
        tableIngresos.draw();
    });

    $('#max, #min').on('change', function () {
        tableIngresos.draw();
    })

    

    

 //NUEVO 


 

 fntViewEgresos();

}, false);

function borrarF(){  
 location.reload();
}

function fntViewEgresos(){
 let request = (window.XMLHttpRequest) ? new XMLHttpRequest() : new ActiveXObject('Microsoft.XMLHTTP');
 let ajaxUrl = base_url+'/Egresos/getEgreso/';
 request.open("GET",ajaxUrl,true);
 request.send();
 request.onreadystatechange = function(){
     if(request.readyState == 4 && request.status == 200){
         let objData = JSON.parse(request.responseText);
         if(objData.status)
         {   
             if (objData.data.imptotal > 0 || objData.data.imptotal < 0) {
                 document.querySelector("#totpagado").innerHTML = 'TOTAL DE EGRESOS S/. '+ objData.data.imptotal;
             }else{
                 document.querySelector("#totpagado").innerHTML = 'TOTAL DE EGRESOS S/. 0.00';

             }
            // alert(objData.data.imptotal)              
           
         }else{
             swal("Error", objData.msg , "error");
         }
     }
 }
}

